#pragma once

class oFont
{
protected:
	oTexture texture;
	oHeapPtr<uchar>::Type widths;
	uchar height;

public:
	oFont() throw();

	void LoadFromFiles(IDirect3DDevice8* const& device, const _TCHAR* const& textureFileName, const _TCHAR* const& widthsFileName);
	
	IDirect3DTexture8* const& GetTexture() const { return texture; }
	const uchar* const& GetWidths() const { return widths; }
	const uchar& GetHeight() const throw() { return height; }
};

class oTextBuffer
{
protected:
	oVertexBuffer<oGUIVertex, oWriteOnlyDynamicBufferTraits> buffer;
	ulong capacity;
	ulong usage;

public:
	oTextBuffer();

	void Create(oGraphics& graphics, const ulong& capacity);

	void Clear() throw();
	void Print(const short& x, const short& y, const _TCHAR* const& text, ulong length, const oFont& font);
	
	void DrawPrimitive(oGraphics& graphics) const;
};