#include "openengine.h"
#include "guiVS.h"
#include "guiPS.h"

ulong oGUIVertex::decl[] = { 	
	D3DVSD_STREAM(0),
	D3DVSD_REG(0, D3DVSDT_SHORT2), // 2d position
	D3DVSD_REG(1, D3DVSDT_FLOAT2), // texture co-ordinate
	D3DVSD_END()
};

void oCreateGUIVertexShader(oGraphics& graphics, oVertexShader& shader)
{
	graphics.CreateVertexShader(shader, oGUIVertex::decl, dwGuiVertexShader);
}

void oCreateGUIPixelShader(oGraphics& graphics, oPixelShader& shader)
{
	graphics.CreatePixelShader(shader, dwGuiPixelShader);
}

void oCreateGUITransform(const long& width, const long& height, oMatrix4x4& transform) throw()
{
	transform.e11 = _R(2) / _R(width-1);
	transform.e14 = _R(-1);
	transform.e22 = -_R(2) / _R(height-1);
	transform.e24 = _R(1);
	transform.e34 = _R(0.5);
	transform.e12 = transform.e13
		= transform.e21 = transform.e23
		= transform.e31 = transform.e32 = transform.e33
		= transform.e41 = transform.e42 = transform.e43 = _R(0); 
	transform.e44 = _R(1); 
}
